#include <QtGui>
#include<cstdio>
#include<unistd.h>
#include<sys/stat.h>
#include"EasyBMP.h"
#include<cstring>
 #include "imageviewer.h"
#include<fstream>
int k=0,g=0,w=0;
extern int doStegno(char* bmpfilepath, char* textfilepath, char* outputPath);
extern int Extractmsg(char *bmpfile,  char* textfile);
void decrypt(char* inoutfilepath, char* key, char* outputfilepath);
void encrypt1(char* inputfile, char* key, char* outputfilepath);


mbox1::mbox1()
{
    tlab1 = new QLabel(this);
    tlab1->setText("please open an image first");
    tlab1->setFont(QFont("Times",12,QFont::Bold));
    setWindowTitle("ERROR");
    button6 = new QPushButton(tr("ok"), this);
        button6->move(70, 30);
        button6->show();
        resize(200,60);
        connect(button6,SIGNAL(clicked()),this,SLOT(close()));

}

mbox2::mbox2()
{
    tlab2 = new QLabel(this);
    tlab2->setText("please load a text file first");
    tlab2->setFont(QFont("Times",12,QFont::Bold));
    setWindowTitle("ERROR");
    button7 = new QPushButton(tr("ok"), this);
        button7->move(70, 30);
        button7->show();
        resize(200,60);
        connect(button7,SIGNAL(clicked()),this,SLOT(close()));

}

dialogbox::dialogbox()
{
    textlabel = new QLabel(tr("password:"),this);
    textlabel->move(50,20);

    lineedit = new QTextEdit(this);
    lineedit->move(120,20);

    button5 = new QPushButton(tr("ok"),this);
        button5->move(125, 60);
    connect(button5,SIGNAL(clicked()),this,SLOT(save()));

    setWindowTitle("password");
    resize(300,100);

}

ImageViewer::ImageViewer()
 {   k=0;g=0;w=0;
     textedit = new QTextEdit(this);
     textedit->resize(900,200);
     textedit->move(50,450);
     textedit->show();

     imageLabel = new QLabel;
     imageLabel->setBackgroundRole(QPalette::Base);

     button = new QPushButton(tr("load"), this);
         button->move(950, 550);
         button->show();
     button2 = new QPushButton(tr("stegno"), this);
         button2->move(950, 400);
         button2->show();
      connect(button2, SIGNAL(clicked()), this, SLOT(stegno()));
      connect(button, SIGNAL(clicked()), this, SLOT(load()));
      button3 = new QPushButton(tr("open"), this);
          button3->move(950, 200);
          button3->show();
      connect(button3, SIGNAL(clicked()), this, SLOT(open()));
      button4 = new QPushButton(tr("destegno"), this);
          button4->move(950, 450);
          button4->show();
          connect(button4,SIGNAL(clicked()),this, SLOT(destegno()));

      imageLabel2 = new QLabel;
      imageLabel2->setBackgroundRole(QPalette::Base);



     scrollArea = new QScrollArea(this);
     scrollArea->setBackgroundRole(QPalette::Dark);
     scrollArea->setWidget(imageLabel);
     scrollArea->resize(400,400);
     scrollArea->move(50,0);


     scrollArea2 = new QScrollArea(this);
     scrollArea2->setBackgroundRole(QPalette::Dark);
     scrollArea2->setWidget(imageLabel2);
     scrollArea2->resize(400,400);
     scrollArea2->move(550,0);




     setWindowTitle(tr("steganography"));
     resize(1050, 700);
 }
 void ImageViewer::load()
 {
     k=1;
     QString fileName = QFileDialog::getOpenFileName(this, tr("Open File"), "",
                  tr("Text Files (*.txt);;C++ Files (*.cpp *.h)"));
     textfile=fileName;

              if (fileName != "") {
                  QFile file(fileName);
                  if (!file.open(QIODevice::ReadOnly)) {
                      QMessageBox::critical(this, tr("Error"),
                          tr("Could not open file"));
                      return;
                  }
                  QString contents = file.readAll().constData();
                  textedit->setPlainText(contents);
                  file.close();


              }
              }

 void ImageViewer::stegno()
 {   if(g==1&&k==1){
          dilogbox.show();
          if(w=1)
         {

            QFile file("/users/cs101/110050063/Desktop/attachments/key.txt");
              QTextStream in(&file);
             key = in.readAll();

             outen = "/users/cs101/110050063/Desktop/attachments/outp.txt";
             encrypt1(textfile.toLocal8Bit().data(), key.toLocal8Bit().data(), outen.toLocal8Bit().data());

             oimg=bmpfile+"_seg.bmp";

             doStegno(bmpfile.toLocal8Bit().data(),outen.toLocal8Bit().data(),oimg.toLocal8Bit().data());
             QImage image2(oimg);

             imageLabel2->setPixmap(QPixmap::fromImage(image2));

            imageLabel2->adjustSize();

          }
          }

         if(g==0)
          {
             box1.show();
         }
         if(g==1&&k==0)
         {
             box2.show();
         }



}

 void ImageViewer::destegno()
 {  if(g==1)
     {
     otext=textfile+"_steg.txt";
     Extractmsg(bmpfile.toLocal8Bit().data(),otext.toLocal8Bit().data());
     QString fileName=otext;
              if (fileName != "") {
                  QFile file(fileName);
                  if (!file.open(QIODevice::ReadOnly)) {
                      QMessageBox::critical(this, tr("Error"),
                          tr("Could not open file"));
                      return;
                  }
                  QString contents = file.readAll().constData();
                  textedit->setPlainText(contents);
                  file.close();
              }
     dilogbox.show();
    }
     if(g!=1)
     {
         box1.show();
     }
     }



 void ImageViewer::open()
 {  g=1;
     QString fileName = QFileDialog::getOpenFileName(this,

                                     tr("Open File"), QDir::currentPath());
     bmpfile=fileName;

     if (!fileName.isEmpty()) {
         QImage image(fileName);
         if (image.isNull()) {
             QMessageBox::information(this, tr("Image Viewer"),
                                      tr("Cannot load %1.").arg(fileName));
             return;
         }
         imageLabel->setPixmap(QPixmap::fromImage(image));

         imageLabel->adjustSize();
     }
        imageLabel2->clear();
     imageLabel2->setBackgroundRole(QPalette::Dark);
     imageLabel2->autoFillBackground();
     textedit->clear();
 }

 void dialogbox::save()
     {
     w=1;
     keyfile = lineedit->toPlainText();
     savelocation = "/users/cs101/110050063/Desktop/attachments";
     QFile ffile(savelocation + "/" + "key.txt");
     if (ffile.open(QFile::WriteOnly)) {
     QTextStream out(&ffile);
     out << lineedit->toPlainText();
     close();
 }


}
