# include <iostream>
#include<cstring>
#include <sys/stat.h>
#include <unistd.h>
#include<stdio.h>


using namespace std;
void decrypt(char* inoutfilepath, char* key, char* outputfilepath);
void encrypt1(char* inputfile, char* key, char* outputfilepath);
char* readFile(char* filename);


int main()
{

	char* key="teen";
	// calling function readFile
	// it will read text file "test.txt" and it's data will be saved in a string text
	char* text = readFile("test.txt");
	cout<<text<<endl;
	int len=strlen(text);
	int keylen=strlen(key);
	// calling function encrypt1
	encrypt1("test.txt",key,"temp.txt");
	// calling function decrypt	
	decrypt("temp.txt",key,"Output.txt");		
 	return 0;
 }

// function decrypt
void decrypt(char* inputfile, char* key, char* outputfile)
{
		int l;
	int size;
	struct stat st;
	if(stat(inputfile, &st) == 0) {
  		size = st.st_size;
	} else {
 		 cout<<"File not found"<<endl;
	}
	size=st.st_size;
	cout<<"Size: "<<size<<endl;
	FILE* input=fopen(inputfile,"r");
	FILE* output=fopen(outputfile,"w");
	int i,n,m,j,k,p,ptr;
	int q=0;
	int *pos;
	char *carray,**A,temp;
	char* inform=readFile(inputfile);
	
	k=0;

	l=size;
	n=strlen(key);		//cols
	if(l%n==0)
		m=l/n;
	else
		m=(l/n)+1;		//rows
	
	pos =new int[n];
	carray=new char[n];

	A = new char*[m];
	for(i = 0; i < m; ++i)
	    A[i] = new char[n];


 	strcpy(carray,key);
	for(i=0;i<n;i++){
 		for(j=i+1;j<n;j++){
 			if(carray[i]>carray[j]){temp=carray[i];carray[i]=carray[j];carray[j]=temp;}
 		}
 	}

 	for(i=0;i<n;i++){
 		for(j=0;j<n;j++){
 			if(key[i]==carray[j])
 				{pos[i]=j; carray[j]='`'; break;}	
 		}
 	}
	
	ptr=0;
	for(i=0;i<n;i++) {
		for(j=0;j<n;j++)
			if(pos[j]==i) { pos[j]=-1; break; }
		for(k=0;k<m;k++) {
			if(inform[ptr]==EOF) A[k][j]=0;
			else A[k][j]=inform[ptr];
			ptr++;
		}
	}
	

	ptr=0;
	for(i=0;i<m;i++)
		for(j=0;j<n;j++) {
				if(A[i][j]!=0) {
					fputc(A[i][j],output);
					cout<<"Writing "<<A[i][j]<<endl;
				}
				
			
		}
	fclose(output);

}
	
// function encrypt1
void encrypt1(char* inputfile, char* key, char* outputfile)
{
	int l;
	int i,n,m,j,k,p,ptr;
	int q=0;
	int *pos;
	FILE* output=fopen(outputfile,"w");
	char* inform,*carray,**A,temp;

	int size;
	struct stat st;
	if(stat(inputfile, &st) == 0) {
  		size = st.st_size;
	} else {
 		 cout<<"File not found"<<endl;
	}

	char* inform1=readFile(inputfile);
	l=size;
	n=strlen(key);		//cols
	if(l%n==0)
		m=l/n;
	else
		m=(l/n)+1;		//rows
	
	pos =new int[n];
	inform=new char[n*m];
	carray=new char[n];

	A = new char*[m];
	for(i = 0; i < m; ++i)
	    A[i] = new char[n];


	m=(l/n)+1;
	k=0;
	for(i=0;i<l;i++)
		inform[i]=inform1[i];
	for(i=l;i<n*m;i++)
		inform[i]=EOF;
	while(k<l){
		for(i=0;i<m;i++){
	        for(j=0;j<n;j++){
               A[i][j]=inform[k];
               k=k+1;
            }
       }
    }

 	strcpy(carray,key);
	for(i=0;i<n;i++){
 		for(j=i+1;j<n;j++){
 			if(carray[i]>carray[j]){temp=carray[i];carray[i]=carray[j];carray[j]=temp;}
 		}
 	}
 	for(i=0;i<n;i++){
 		for(j=0;j<n;j++){
 			if(key[i]==carray[j])
 				{pos[i]=j; carray[j]='`'; break;}
			
			 	
				
 		}
 	}
 	

 	ptr=0;	
 	for(int col=0;col<n;col++) {
 		for(i=0;i<n;i++)
 			if(pos[i]==col) break;
 		for(j=0;j<m;j++) {
			fputc(A[j][i],output);
		}
 	}
	fflush(output);
	fclose(output);

}

// function readFile
char* readFile(char* filename)
{
    FILE* file = fopen(filename,"r");
    if(file == NULL)
    {
        return NULL;
    }

    fseek(file, 0, SEEK_END);
    long int size = ftell(file);
    rewind(file);

    char* content = (char*) calloc(size + 1, 1);

    fread(content,1,size,file);
	// it will now return text file's data that will be used in a string 
    return content;
}
