#ifndef IMAGEVIEWER_H
 #define IMAGEVIEWER_H

 #include <QMainWindow>
 #include <QPrinter>
 #include <QtCore>
 #include <QtGui>

 class QTextEdit;
 class QAction;
 class QLabel;
 class QMenu;
 class QScrollArea;
 class QScrollBar;
 class QPushButton;
 class mbox1 : public QWidget
 {
     Q_OBJECT
   public:
     mbox1();
   private:
     QLabel *tlab1;
     QPushButton *button6;


 };

 class mbox2 : public QWidget
 {
     Q_OBJECT
   public:
     mbox2();
   private:
     QLabel *tlab2;
     QPushButton *button7;


 };

 class dialogbox : public QWidget
  {
     Q_OBJECT
   public:
     dialogbox();

   private slots :
     void save();

   private :
     QTextEdit *lineedit;
     QLabel *textlabel;
     QPushButton *button5;
     QString keyfile,savelocation;
 };

 class ImageViewer : public QMainWindow
 {
     Q_OBJECT

 public:
     ImageViewer();

 private slots:
     void stegno();
     void destegno();
     void load();
     void open();


 private:

     QPushButton *button3,*button4;
     QPushButton *button2;
     QPushButton *button;
     QTextEdit *textedit;
     QLabel *imageLabel;
     QLabel *imageLabel2;
     QScrollArea *scrollArea;
     QScrollArea *scrollArea2;
     dialogbox dilogbox;
     mbox1 box1;
     mbox2 box2;
     QString bmpfile, textfile, newbmpfile, newtextfile ,oimg ,otext,key,outen;


 };

 #endif
